/*
 ܺĺ  ·ʵ
*/
#include "RainDrop128128_coreE.h"

static  const unsigned char _C_ALIGN16(Lbswap_maskU[16]) = { 15, 14, 13, 12 ,11, 10, 9, 8,7, 6, 5,4, 3, 2, 1, 0, };
static  const unsigned char _C_ALIGN16(Lbswap_maskU1[16]) = { 14, 15,12 ,13, 10,11,   8,9, 6,7,4,  5, 2,3, 0, 1, };
static  const unsigned char _C_ALIGN16(Lbswap_maskB[16]) = { 2,3,10,11,6,7,14,15,0,1,8,9,4,5,12,13, };
static  const unsigned char _C_ALIGN16(Lbswap_maskF[16]) = { 0,2,4,6,8,10,12,14,1,3,5,7,9,11,13,15 };
static  const unsigned char _C_ALIGN16(Lbswap_mask[16]) = { 1,1,2,2,4,4,8,8,16,16,32,32,64,64,128,128 };
static  const unsigned char _C_ALIGN16(Lbswap_mask0[16]) = { 1,	3,	5,	7,9,	11,	13,	15,	0,	2,	4,	6,8,	10,	12,	14, };
static  const unsigned char _C_ALIGN16(LbRound0_mask[16]) = { 4, 0, 1,  2,  3,  7, 5, 6,  12, 8, 9,     10, 11,  15 ,13, 14, };
static  const unsigned char _C_ALIGN16(LbRound1_mask[16]) = { 3,4,0, 1,  2,  6,  7,  5, 11,  12,8, 9, 10, 14, 15, 13, };
static  const unsigned char _C_ALIGN16(lb_mask3[16]) = { 8,9,8,9,8,9,8,9,8,9,8,9,8,9,8,9, };
static  const unsigned char _C_ALIGN16(lb_mask2[16]) = { 10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11, };
static  const unsigned char _C_ALIGN16(lb_mask1[16]) = { 12,13,12,13,12,13,12,13,12,13,12,13,12,13,12,13, };
static  const unsigned char _C_ALIGN16(lb_mask0[16]) = { 14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15, };
static  const u16i _C_ALIGN16(RDLbswap_mask0[8]) = { 0x0020, 0,0, 0,0,0, 0x8010, 0x0400 };
static  const u16i _C_ALIGN16(RDLbswap_mask1[8]) = { 0x0020, 0,0, 0,0,0, 0x0400, 0x0420 };
static  const u16i _C_ALIGN16(RDLbswap_mask2[8]) = { 0, 0,0, 0,0,0x83f0, 0xfc1f, 0x07e0 };
static  const u16i _C_ALIGN16(RDLbswap_mask5[8]) = { 0x0400, 0x0020,0, 0,0,0,  0, 0x8010 };
static  const u16i _C_ALIGN16(RDLbswap_mask6[8]) = { 0, 0x0020,0, 0,0,0,  0, 0x0400 };
static  const u16i _C_ALIGN16(RDLbswap_mask7[8]) = { 0x0020,0,0, 0,0,0,  0, 0 };




#define Sbox35_comb(l2) \
	t0= (l2<<1)& 0xDEDEDEDEDEDEDEDE;\
	t1= (l2>>2)& 0x2020202020202020;\
	t4= (l2>>4)& 0x0101010101010101;\
	t2= (l2<<2)& 0x9C9C9C9C9C9C9C9C;\
	t3= (l2>>1)& 0x6060606060606060;\
	t5= (l2>>3)& 0x0303030303030303;\
	l2=  l2^((~(t0|t1|t4 ))&(t2|t3|t5));

 void RainDropGenRK_128_128_ENC(u8i * Rk, u8i * K )
{
	__m128i   t2;
	__m128i B, C, D, E, F, G, H;
	u64i *RRk = (u64i *)Rk;
	const __m128i MSK = _mm_load_si128((__m128i*) Lbswap_maskU1);
	const __m128i all0 = _mm_xor_si128(MSK, MSK);
	__m128i A = _mm_shuffle_epi8(_mm_loadu_si128((__m128i*)K), _mm_load_si128((__m128i*) Lbswap_maskU));
	__m128i MASK0 = _mm_load_si128((__m128i*) RDLbswap_mask0);
	__m128i MASK1 = _mm_load_si128((__m128i*) RDLbswap_mask1);
	__m128i MASK2 = _mm_load_si128((__m128i*) RDLbswap_mask2);
	__m128i MASK5 = _mm_load_si128((__m128i*) RDLbswap_mask5);
	__m128i MASK6 = _mm_load_si128((__m128i*) RDLbswap_mask6);
	__m128i MASK7 = _mm_load_si128((__m128i*) RDLbswap_mask7);
	u16i i; 
		H = _mm_shuffle_epi8(A, MSK);
		*RRk = _mm_extract_epi64(H, 0); RRk++;
		for (i = 1; i < RoundRainDrop128128; i++)
		{
			t2 = _mm_insert_epi16(all0, i, 4);
			A = _mm_xor_si128(A, t2);
			Fun_B_SimdB(A, B, C, D, E, F, G, H);
			H = _mm_shuffle_epi8(A, MSK); 
			*RRk = _mm_extract_epi64(H, 0); RRk++;
		}
}  

#define SingleRoundRainDrop128128T(L0,R0,rk)\
K0 = L0; \
Sbox35_comb(K0); \
	*(m0) = (*(((u16i *)&K0) + 1)) ^ (*(((u16i *)&K0) + 3));\
	*(m0 + 1) = ROTL16(((*(((u16i *)&K0) + 2)) ^ (*(((u16i *)&K0) + 3))), 6);\
	*(m0 + 2) = ROTL16((*(((u16i *)&K0))), 7);\
	*(m0 + 3) = ROTL16((*(((u16i *)&K0) + 1)) ^ (*(((u16i *)&K0))), 12);\
	R0^=t0 ^ (*((u64i *)(rk)));

void  RainDrop128128EncDataS(u8i *out, u8i *cp, u8i *rk)
{ 
	u64i L0;
	u64i R0;
	u64i K0;
	u64i t0, t1, t2, t3, t4, t5;
	u16i* k0 = (u16i *)( &K0);
	u16i* l0 = (u16i *)(&L0);
	u16i *m0 = (u16i *)(&t0);
	int i;
	t0 = *((u64i *)cp);
	t1 = *((u64i *)(cp + 8));

	L0 = ((t0 << 8) & 0xFF00FF00FF00FF00) | ((t0 >> 8) & 0x00FF00FF00FF00FF);
	R0 = ((t1 << 8) & 0xFF00FF00FF00FF00) | ((t1 >> 8) & 0x00FF00FF00FF00FF);  
	for (i = 0; i < RoundRainDrop128128; i += 2)
	{ 
		SingleRoundRainDrop128128T(L0, R0, (u64i *)(rk + i * 8));
		SingleRoundRainDrop128128T(R0, L0, (u64i *)(rk + i * 8 + 8)); 
	}

	*((u64i *)(out)) = ((R0 << 8) & 0xFF00FF00FF00FF00) | ((R0 >> 8) & 0x00FF00FF00FF00FF);
	*((u64i *)(out + 8)) = ((L0 << 8) & 0xFF00FF00FF00FF00) | ((L0 >> 8) & 0x00FF00FF00FF00FF); 
}