/*
 ܺĺ  ·ʵ
*/
#include "RainDrop128256_coreD.h"


#define  BLEN2 32 
static  const unsigned char _C_ALIGN32(Lbswap_maskB[BLEN2]) = { 2,3,10,11,6,7,14,15,0,1,8,9,4,5,12,13, 2,3,10,11,6,7,14,15,0,1,8,9,4,5,12,13, };
static  const unsigned char _C_ALIGN32(RLbswap_mask[BLEN2]) = { 1,1,2,2,4,4,8,8,16,16,32,32,64,64,128,128 ,1,1,2,2,4,4,8,8,16,16,32,32,64,64,128,128 };
static  const unsigned char _C_ALIGN32(RLbswap_mask0[BLEN2]) = { 1,	3,	5,	7,9,	11,	13,	15,	0,	2,	4,	6,8,	10,	12,	14,1,	3,	5,	7,9,	11,	13,	15,	0,	2,	4,	6,8,	10,	12,	14, };
static  const unsigned char _C_ALIGN32(LbRound0_mask[BLEN2]) = { 4, 0, 1,  2,  3,  7, 5, 6,  12, 8, 9,     10, 11,  15 ,13, 14,4, 0, 1,  2,  3,  7, 5, 6,  12, 8, 9,     10, 11,  15 ,13, 14, };
static  const unsigned char _C_ALIGN32(LbRound1_mask[BLEN2]) = { 3,4,0, 1,  2,  6,  7,  5, 11,  12,8, 9, 10, 14, 15, 13,3,4,0, 1,  2,  6,  7,  5, 11,  12,8, 9, 10, 14, 15, 13, };
static  const unsigned char _C_ALIGN32(lb_mask3[BLEN2]) = { 2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3, };
static  const unsigned char _C_ALIGN32(lb_mask2[BLEN2]) = { 6,7,6,7,6,7,6,7,6,7,6,7,6,7,6,7, 6,7,6,7,6,7,6,7,6,7,6,7,6,7,6,7, };
static  const unsigned char _C_ALIGN32(lb_mask1[BLEN2]) = { 10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11, };
static  const unsigned char _C_ALIGN32(lb_mask0[BLEN2]) = { 14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15, };
static  const unsigned char _C_ALIGN32(Lbswap_maskA[BLEN2]) = { 15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0, };
static  const u32i  _C_ALIGN16(Lbswap_mask0[4]) = { 0,0,0,0xFC000000, };
static  const u64i  _C_ALIGN16(Lbswap_mask2[2]) = { 0,0x000fc001F8000000, };
static  const u64i  _C_ALIGN16(Lbswap_mask3[2]) = { 0x07F0000000000000,0x000FE001FC003F80, };
static  const u64i  _C_ALIGN16(Lbswap_mask4[2]) = { 0x03800070000E0000,0x0000000000001C00, };
static  const u64i  _C_ALIGN16(Lbswap_mask5[2]) = { 0,0xfc001f8003F00000, };
static  const u64i  _C_ALIGN16(Lbswap_mask6[2]) = { 0x000000000007e000,0, };

#define genavxrkA(p,A, lb_mask0 ,MSK,MSK0,tl)\
    tl= _mm256_broadcastsi128_si256(A);\
	tl=_mm256_shuffle_epi8(tl, _mm256_load_si256((__m256i*)lb_mask0));\
	tl= _mm256_and_si256(tl,MSK );\
	tl = _mm256_cmpeq_epi8( tl , MSK);\
	*(p)= _mm256_shuffle_epi8(tl, MSK0);

#define  SboxSkinnyLike128( out,in,T,T1) \
	T= _mm_shuffle_epi8(in,_mm_load_si128((__m128i*)LbRound0_mask ));\
	T1= _mm_shuffle_epi8(in,_mm_load_si128((__m128i*)LbRound1_mask ));	\
	out= _mm_xor_si128( _mm_andnot_si128(T, T1),in);  

#define 	   RD_RF(E4,E5,E6,E7,E0,E1,E2,E3,D0,D1,D2,D3,d0,d1,d2,d3,p)\
	SboxSkinnyLike128(d0,E0,D0,D1);     SboxSkinnyLike128(d1,E1,D2,D3);\
	SboxSkinnyLike128(d2,E2,D0,D1);   SboxSkinnyLike128(d3,E3,D2,D3); \
	D0= _mm_xor_si128(d1,d3);\
	D1= _mm_xor_si128(d2,d3);\
	D1= _mm_alignr_epi8(D1,D1,10);\
	D2= _mm_alignr_epi8(d0,d0,9);\
	D3= _mm_xor_si128(d0,d1);\
	D3= _mm_alignr_epi8(D3,D3,4);\
	E4 = _mm_xor_si128( E4,D0 );\
	E5 = _mm_xor_si128( E5,D1);\
	E6 = _mm_xor_si128( E6,D2 );\
	E7 = _mm_xor_si128( E7,D3 );\
	E4 = _mm_xor_si128( E4,*(p+0) );\
	E5 = _mm_xor_si128( E5,*(p+1) );\
	E6 = _mm_xor_si128( E6,*(p+2) );\
	E7 = _mm_xor_si128( E7,*(p+3) );

#define  DataSlicing(E0,E1,E2,E3,E4,E5,E6,E7,D0,D1,D2,D3,D4,D5,D6,D7) \
	E0=  _mm_unpacklo_epi8(D0, D4);\
	E4=  _mm_unpackhi_epi8(D0, D4);\
	E1=  _mm_unpacklo_epi8(D1, D5);\
	E5=  _mm_unpackhi_epi8(D1, D5);\
	E2=  _mm_unpacklo_epi8(D2, D6);\
	E6=  _mm_unpackhi_epi8(D2, D6);\
	E3=  _mm_unpacklo_epi8(D3, D7);\
	E7=  _mm_unpackhi_epi8(D3, D7);\
	\
	D0=  _mm_unpacklo_epi8(E0, E2);\
	D2=  _mm_unpackhi_epi8(E0, E2);\
	D1=  _mm_unpacklo_epi8(E1, E3);\
	D3=  _mm_unpackhi_epi8(E1, E3);\
	D4=  _mm_unpacklo_epi8(E4, E6);\
	D6=  _mm_unpackhi_epi8(E4, E6);\
	D5=  _mm_unpacklo_epi8(E5, E7);\
	D7=  _mm_unpackhi_epi8(E5, E7); \
	\
	E0=  _mm_unpacklo_epi8(D0, D1);\
	E1=  _mm_unpackhi_epi8(D0, D1);\
	E2=  _mm_unpacklo_epi8(D2, D3);\
	E3=  _mm_unpackhi_epi8(D2, D3);\
	E4=  _mm_unpacklo_epi8(D4, D5);\
	E5=  _mm_unpackhi_epi8(D4, D5);\
	E6=  _mm_unpacklo_epi8(D6, D7);\
	E7=  _mm_unpackhi_epi8(D6, D7); 

#define  VDataSlicing(E0,E1,E2,E3,E4,E5,E6,E7,D0,D1,D2,D3,D4,D5,D6,D7) \
	E0=  _mm_unpacklo_epi8(D0, D1);\
	E1=  _mm_unpackhi_epi8(D0, D1);\
	E2=  _mm_unpacklo_epi8(D2, D3);\
	E3=  _mm_unpackhi_epi8(D2, D3);\
	E4=  _mm_unpacklo_epi8(D4, D5);\
	E5=  _mm_unpackhi_epi8(D4, D5);\
	E6=  _mm_unpacklo_epi8(D6, D7);\
	E7=  _mm_unpackhi_epi8(D6, D7); \
	\
	D0=  _mm_unpacklo_epi8(E0, E2);\
	D2=  _mm_unpackhi_epi8(E0, E2);\
	D1=  _mm_unpacklo_epi8(E1, E3);\
	D3=  _mm_unpackhi_epi8(E1, E3);\
	D4=  _mm_unpacklo_epi8(E4, E6);\
	D6=  _mm_unpackhi_epi8(E4, E6);\
	D5=  _mm_unpacklo_epi8(E5, E7);\
	D7=  _mm_unpackhi_epi8(E5, E7); \
	\
	E0=  _mm_unpacklo_epi8(D0, D4);\
	E4=  _mm_unpackhi_epi8(D0, D4);\
	E1=  _mm_unpacklo_epi8(D1, D5);\
	E5=  _mm_unpackhi_epi8(D1, D5);\
	E2=  _mm_unpacklo_epi8(D2, D6);\
	E6=  _mm_unpackhi_epi8(D2, D6);\
	E3=  _mm_unpacklo_epi8(D3, D7);\
	E7=  _mm_unpackhi_epi8(D3, D7);\
	\
	D0=  _mm_unpacklo_epi8(E0,E1);\
	D1=  _mm_unpackhi_epi8(E0, E1);\
	D4=  _mm_unpacklo_epi8(E2, E3);\
	D5=  _mm_unpackhi_epi8(E2, E3);\
	D2=  _mm_unpacklo_epi8(E4, E5);\
	D3=  _mm_unpackhi_epi8(E4, E5);\
	D6=  _mm_unpacklo_epi8(E6, E7);\
	D7=  _mm_unpackhi_epi8(E6, E7);  


#define  SboxSkinnyLike256( out,in,T,T1) \
	T= _mm256_shuffle_epi8(in,_mm256_load_si256((__m256i*)LbRound0_mask ));\
	T1= _mm256_shuffle_epi8(in,_mm256_load_si256((__m256i*)LbRound1_mask ));	\
	out= _mm256_xor_si256( _mm256_andnot_si256(T, T1),in);  

#define 	   RD_RF256(E4,E5,E6,E7,E0,E1,E2,E3,D0,D1,D2,D3,d0,d1,d2,d3,p)\
	SboxSkinnyLike256(d0,E0,D0,D1);     SboxSkinnyLike256(d1,E1,D2,D3);\
	SboxSkinnyLike256(d2,E2,D0,D1);   SboxSkinnyLike256(d3,E3,D2,D3); \
	D0= _mm256_xor_si256(d1,d3);\
	D1= _mm256_xor_si256(d2,d3);\
	D1= _mm256_alignr_epi8(D1,D1,10);\
	D2= _mm256_alignr_epi8(d0,d0,9);\
	D3= _mm256_xor_si256(d0,d1);\
	D3= _mm256_alignr_epi8(D3,D3,4);\
	E4 = _mm256_xor_si256( E4,D0 );\
	E5 = _mm256_xor_si256( E5,D1);\
	E6 = _mm256_xor_si256( E6,D2 );\
	E7 = _mm256_xor_si256( E7,D3 );\
	E4 = _mm256_xor_si256( E4,*(p+0) );\
	E5 = _mm256_xor_si256( E5,*(p+1) );\
	E6 = _mm256_xor_si256( E6,*(p+2) );\
	E7 = _mm256_xor_si256( E7,*(p+3) );

#define  DataSlicing256(E0,E1,E2,E3,E4,E5,E6,E7,D0,D1,D2,D3,D4,D5,D6,D7) \
	E0=  _mm256_unpacklo_epi8(D0, D4);\
	E4=  _mm256_unpackhi_epi8(D0, D4);\
	E1=  _mm256_unpacklo_epi8(D1, D5);\
	E5=  _mm256_unpackhi_epi8(D1, D5);\
	E2=  _mm256_unpacklo_epi8(D2, D6);\
	E6=  _mm256_unpackhi_epi8(D2, D6);\
	E3=  _mm256_unpacklo_epi8(D3, D7);\
	E7=  _mm256_unpackhi_epi8(D3, D7);\
	\
	D0=  _mm256_unpacklo_epi8(E0, E2);\
	D2=  _mm256_unpackhi_epi8(E0, E2);\
	D1=  _mm256_unpacklo_epi8(E1, E3);\
	D3=  _mm256_unpackhi_epi8(E1, E3);\
	D4=  _mm256_unpacklo_epi8(E4, E6);\
	D6=  _mm256_unpackhi_epi8(E4, E6);\
	D5=  _mm256_unpacklo_epi8(E5, E7);\
	D7=  _mm256_unpackhi_epi8(E5, E7); \
	\
	E0=  _mm256_unpacklo_epi8(D0, D1);\
	E1=  _mm256_unpackhi_epi8(D0, D1);\
	E2=  _mm256_unpacklo_epi8(D2, D3);\
	E3=  _mm256_unpackhi_epi8(D2, D3);\
	E4=  _mm256_unpacklo_epi8(D4, D5);\
	E5=  _mm256_unpackhi_epi8(D4, D5);\
	E6=  _mm256_unpacklo_epi8(D6, D7);\
	E7=  _mm256_unpackhi_epi8(D6, D7); 

#define  VDataSlicing256(E0,E1,E2,E3,E4,E5,E6,E7,D0,D1,D2,D3,D4,D5,D6,D7) \
	E0=  _mm256_unpacklo_epi8(D0, D1);\
	E1=  _mm256_unpackhi_epi8(D0, D1);\
	E2=  _mm256_unpacklo_epi8(D2, D3);\
	E3=  _mm256_unpackhi_epi8(D2, D3);\
	E4=  _mm256_unpacklo_epi8(D4, D5);\
	E5=  _mm256_unpackhi_epi8(D4, D5);\
	E6=  _mm256_unpacklo_epi8(D6, D7);\
	E7=  _mm256_unpackhi_epi8(D6, D7); \
	\
	D0=  _mm256_unpacklo_epi8(E0, E2);\
	D2=  _mm256_unpackhi_epi8(E0, E2);\
	D1=  _mm256_unpacklo_epi8(E1, E3);\
	D3=  _mm256_unpackhi_epi8(E1, E3);\
	D4=  _mm256_unpacklo_epi8(E4, E6);\
	D6=  _mm256_unpackhi_epi8(E4, E6);\
	D5=  _mm256_unpacklo_epi8(E5, E7);\
	D7=  _mm256_unpackhi_epi8(E5, E7); \
	\
	E0=  _mm256_unpacklo_epi8(D0, D4);\
	E4=  _mm256_unpackhi_epi8(D0, D4);\
	E1=  _mm256_unpacklo_epi8(D1, D5);\
	E5=  _mm256_unpackhi_epi8(D1, D5);\
	E2=  _mm256_unpacklo_epi8(D2, D6);\
	E6=  _mm256_unpackhi_epi8(D2, D6);\
	E3=  _mm256_unpacklo_epi8(D3, D7);\
	E7=  _mm256_unpackhi_epi8(D3, D7);\
	\
	D0=  _mm256_unpacklo_epi8(E0,E1);\
	D1=  _mm256_unpackhi_epi8(E0, E1);\
	D4=  _mm256_unpacklo_epi8(E2, E3);\
	D5=  _mm256_unpackhi_epi8(E2, E3);\
	D2=  _mm256_unpacklo_epi8(E4, E5);\
	D3=  _mm256_unpackhi_epi8(E4, E5);\
	D6=  _mm256_unpacklo_epi8(E6, E7);\
	D7=  _mm256_unpackhi_epi8(E6, E7);  




static void swapmove256(__m256i * a, __m256i * b, int n, __m256i m)
{
	__m256i t;
	t = _mm256_srli_epi32(*b, n);
	t = _mm256_xor_si256(*a, t);
	t = _mm256_and_si256(m, t);
	*a = _mm256_xor_si256(*a, t);
	t = _mm256_slli_epi32(t, n);
	*b = _mm256_xor_si256(*b, t);
}
static void bitslice256(__m256i * x0, __m256i * x1, __m256i * x2, __m256i * x3, __m256i *  x4, __m256i *  x5, __m256i * x6, __m256i * x7)
{
	__m256i t0 = _mm256_set1_epi32(0x55555555);
	swapmove256(x7, x6, 1, t0);
	swapmove256(x5, x4, 1, t0);
	swapmove256(x3, x2, 1, t0);
	swapmove256(x1, x0, 1, t0);
	t0 = _mm256_set1_epi32(0x33333333);
	swapmove256(x7, x5, 2, t0);
	swapmove256(x6, x4, 2, t0);
	swapmove256(x3, x1, 2, t0);
	swapmove256(x2, x0, 2, t0);
	t0 = _mm256_set1_epi32(0x0f0f0f0f);
	swapmove256(x7, x3, 4, t0);
	swapmove256(x6, x2, 4, t0);
	swapmove256(x5, x1, 4, t0);
	swapmove256(x4, x0, 4, t0);
}


void RainDropGenRK_128_256M_DEC(__m256i * Rk, u8i * K)
{
	__m128i A, B, C, D, E, F, G, H;
	__m256i *p = Rk;
	__m256i tl;
	u32i i;
	const __m256i MSK = _mm256_load_si256((__m256i*) RLbswap_mask);
	const __m256i MSK0 = _mm256_load_si256((__m256i*) RLbswap_mask0);
	__m128i MASK0 = _mm_load_si128((__m128i*) Lbswap_mask0);
	__m128i MASK2 = _mm_load_si128((__m128i*) Lbswap_mask2);
	__m128i MASK3 = _mm_load_si128((__m128i*) Lbswap_mask3);
	__m128i MASK4 = _mm_load_si128((__m128i*) Lbswap_mask4);
	__m128i MASK5 = _mm_load_si128((__m128i*) Lbswap_mask5);
	__m128i MASK6 = _mm_load_si128((__m128i*) Lbswap_mask6);
	const __m128i all0 = _mm_xor_si128(MASK0, MASK0);
	A = _mm_shuffle_epi8(_mm_loadu_si128((__m128i*)K), _mm_load_si128((__m128i*) Lbswap_maskA));
	B = _mm_shuffle_epi8(_mm_loadu_si128((__m128i*)(K + 16)), _mm_load_si128((__m128i*) Lbswap_maskA));
 
		p += (RoundRainDrop128256 * 4) - 1;
		genavxrkA((p - 3), A, lb_mask0, MSK, MSK0, tl);
		genavxrkA((p - 2), A, lb_mask1, MSK, MSK0, tl);
		genavxrkA((p - 1), A, lb_mask2, MSK, MSK0, tl);
		genavxrkA((p - 0), A, lb_mask3, MSK, MSK0, tl);
		p -= 4;
		for (i = 1; i < RoundRainDrop128256; i++)
		{
			H = _mm_insert_epi32(all0, i, 1);
			A = _mm_xor_si128(A, H);
			Fun_D_SimdA(A, B, C, D, E, F, G, H);
			genavxrkA((p - 3), A, lb_mask0, MSK, MSK0, tl);
			genavxrkA((p - 2), A, lb_mask1, MSK, MSK0, tl);
			genavxrkA((p - 1), A, lb_mask2, MSK, MSK0, tl);
			genavxrkA((p - 0), A, lb_mask3, MSK, MSK0, tl);
			p -= 4;
		} 
}

void RainDrop128256EncDataM_CBC(u8i *out, u8i *pt, u8i *rk, __m128i *IV)
{
	int i;
	__m128i TX0;
	__m256i E0, E1, E2, E3, E4, E5, E6, E7;
	__m256i *p = (__m256i *)rk;
	__m256i D0 = _mm256_loadu_si256((__m256i*)pt);
	__m256i D1 = _mm256_loadu_si256((__m256i*)(pt + BLEN2));
	__m256i D2 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 2));
	__m256i D3 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 3));
	__m256i D4 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 4));
	__m256i D5 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 5));
	__m256i D6 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 6));
	__m256i D7 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 7));
	__m256i d0, d1, d2, d3, d4, d5, d6, d7;
	bitslice256(&D0, &D1, &D2, &D3, &D4, &D5, &D6, &D7);
	DataSlicing256(E0, E1, E2, E3, E4, E5, E6, E7, D0, D1, D2, D3, D4, D5, D6, D7);
	for (i = 0; i < RoundRainDrop128256 / 2; i++)
	{
		RD_RF256(E4, E5, E6, E7, E0, E1, E2, E3, D0, D1, D2, D3, d0, d1, d2, d3, p);
		RD_RF256(E0, E1, E2, E3, E4, E5, E6, E7, D0, D1, D2, D3, d0, d1, d2, d3, p + 4);
		p += 8;
	}
	VDataSlicing256(D0, D1, D2, D3, D4, D5, D6, D7, E0, E1, E2, E3, E4, E5, E6, E7);
	bitslice256(&E0, &E1, &E2, &E3, &E4, &E5, &E6, &E7);
	D0 = _mm256_shuffle_epi8(E0, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D1 = _mm256_shuffle_epi8(E1, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D2 = _mm256_shuffle_epi8(E2, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D3 = _mm256_shuffle_epi8(E3, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D5 = _mm256_shuffle_epi8(E5, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D6 = _mm256_shuffle_epi8(E6, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D7 = _mm256_shuffle_epi8(E7, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D4 = _mm256_shuffle_epi8(E4, _mm256_load_si256((__m256i*) Lbswap_maskB));
	TX0 = _mm_loadu_si128((__m128i*)(pt));
	E0 = _mm256_inserti128_si256(E0, *IV, 0);
	E0 = _mm256_inserti128_si256(E0, TX0, 1);
	E1 = _mm256_loadu_si256((__m256i*)(pt + 16));
	E2 = _mm256_loadu_si256((__m256i*)(pt + 16 * 3));
	E3 = _mm256_loadu_si256((__m256i*)(pt + 16 * 5));
	E4 = _mm256_loadu_si256((__m256i*)(pt + 16 * 7));
	E5 = _mm256_loadu_si256((__m256i*)(pt + 16 * 9));
	E6 = _mm256_loadu_si256((__m256i*)(pt + 16 * 11));
	E7 = _mm256_loadu_si256((__m256i*)(pt + 16 * 13));
	*IV = _mm_loadu_si128((__m128i*)(pt + 16 * 15));

	_mm256_storeu_si256((__m256i*)(out), _mm256_xor_si256(D0, E0));
	_mm256_storeu_si256((__m256i*)(out + 32), _mm256_xor_si256(D1, E1));
	_mm256_storeu_si256((__m256i*)(out + 32 * 2), _mm256_xor_si256(D2, E2));
	_mm256_storeu_si256((__m256i*)(out + 32 * 3), _mm256_xor_si256(D3, E3));
	_mm256_storeu_si256((__m256i*)(out + 32 * 4), _mm256_xor_si256(D4, E4));
	_mm256_storeu_si256((__m256i*)(out + 32 * 5), _mm256_xor_si256(D5, E5));
	_mm256_storeu_si256((__m256i*)(out + 32 * 6), _mm256_xor_si256(D6, E6));
	_mm256_storeu_si256((__m256i*)(out + 32 * 7), _mm256_xor_si256(D7, E7));
}


void RainDrop128256EncDataM(u8i *out, u8i *pt, u8i *rk)
{
	int i;
	__m256i E0, E1, E2, E3, E4, E5, E6, E7;
	__m256i *p = (__m256i *)rk;
	__m256i D0 = _mm256_loadu_si256((__m256i*)pt);
	__m256i D1 = _mm256_loadu_si256((__m256i*)(pt + BLEN2));
	__m256i D2 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 2));
	__m256i D3 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 3));
	__m256i D4 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 4));
	__m256i D5 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 5));
	__m256i D6 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 6));
	__m256i D7 = _mm256_loadu_si256((__m256i*)(pt + BLEN2 * 7));
	__m256i d0, d1, d2, d3, d4, d5, d6, d7;
	bitslice256(&D0, &D1, &D2, &D3, &D4, &D5, &D6, &D7);
	DataSlicing256(E0, E1, E2, E3, E4, E5, E6, E7, D0, D1, D2, D3, D4, D5, D6, D7);
	for (i = 0; i < RoundRainDrop128256 / 2; i++)
	{
		RD_RF256(E4, E5, E6, E7, E0, E1, E2, E3, D0, D1, D2, D3, d0, d1, d2, d3, p);
		RD_RF256(E0, E1, E2, E3, E4, E5, E6, E7, D0, D1, D2, D3, d0, d1, d2, d3, p + 4);
		p += 8;
	}
	VDataSlicing256(D0, D1, D2, D3, D4, D5, D6, D7, E0, E1, E2, E3, E4, E5, E6, E7);
	bitslice256(&E0, &E1, &E2, &E3, &E4, &E5, &E6, &E7);
	D0 = _mm256_shuffle_epi8(E0, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D1 = _mm256_shuffle_epi8(E1, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D2 = _mm256_shuffle_epi8(E2, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D3 = _mm256_shuffle_epi8(E3, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D5 = _mm256_shuffle_epi8(E5, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D6 = _mm256_shuffle_epi8(E6, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D7 = _mm256_shuffle_epi8(E7, _mm256_load_si256((__m256i*) Lbswap_maskB));
	D4 = _mm256_shuffle_epi8(E4, _mm256_load_si256((__m256i*) Lbswap_maskB));

	_mm256_storeu_si256((__m256i*)(out), D0);
	_mm256_storeu_si256((__m256i*)(out + BLEN2 * 1), D1);
	_mm256_storeu_si256((__m256i*)(out + BLEN2 * 2), D2);
	_mm256_storeu_si256((__m256i*)(out + BLEN2 * 3), D3);
	_mm256_storeu_si256((__m256i*)(out + BLEN2 * 4), D4);
	_mm256_storeu_si256((__m256i*)(out + BLEN2 * 5), D5);
	_mm256_storeu_si256((__m256i*)(out + BLEN2 * 6), D6);
	_mm256_storeu_si256((__m256i*)(out + BLEN2 * 7), D7);
}